/* BEGIN NOTICE

This software was written by Peter DiFalco and John Sarraille.  The
algorithm employed was inspired by the paper entitled "A Fast
Algorithm To Determine Fractal Dimensions By Box Counting", which was
written by Liebovitch and Toth, and which appeared in the journal
"Physics Letters A", volume 141, pp 386-390, (1989).

This software is not warranteed: use at your own risk.  Unlimited
permission to distribute this software is granted, so long as this
notice is included in all copies made.

Sept 2, 1991

END NOTICE */

/*
fd.h
  Header file for Fractal Dimension Programs
*/

#define MASK(n)		(((unsigned long int) 1)<<(n))
#define IS_A_ONE(x,n)	((x) & MASK(n))
#define false		(0)
#define true		(1)
#define sizul		sizeof(unsigned long int)
#define numbits		(8*sizul)
/* Use this (change to true) for a small amount of checking. */
#define checking   (false)  

/* This gives EXCESSIVE output -- even with tiny input sets -- use in a way
   that allows you to abort when you have seen enough. */
#define debugging (false) 

typedef unsigned long int	ulong;

typedef struct QHeader
{
   long int  Qfront,	/* indexes used as pointers to the front */
	     Qrear;     /* and rear of the queue */
} QHeader;

/*  Some things that are global variables. */
 FILE  *infile;
 int   embed_dim,         /* How many coordinates points have. */
             *marker;           /*  To mark queues during radix sort */
 ulong **data_array,	/* initial array of data points */
             numpoints,        /* number of data points in input file */
            *diff_test; 	 /* XOR's of pairs of coordinates */
 long int  *next_after,    /*  array for pointers to data_array. */
                 avail;             /*  avail list pointer */
 QHeader Q[2];       /* array of two queues for the radix sort */
